// Copyright (C) 2011 by TOMITA Hiroshi.
//     This program is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.

//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.

var CAgent = function (a) {
    this.agt = a;
    
    // [[x, y, goalID, nextWPID, default_speed ] ...]

    for(i=0; i<this.agt.length; i++){
        if(this.agt[i][2] != -1)
            for(j=0; j<object.goal.length; j++)
                if(this.agt[i][2] == object.goal[j].pairID)
                    object.links[object.links.length] = [T_PED, T_GOAL, i, j];
        if(this.agt[i][3] != -1)
            for(j=0; j<object.waypoint.length; j++)
                if(this.agt[i][3] == object.waypoint[j].WPID)
                    object.links[object.links.length] = [T_PED, T_WAYPOINT, i, j];
    }

    this.add = function(x,y,goalID,wpid,speed){
        var goalIndex = -1;
        var wpIndex = -1;
        if(goalID != -1){
            for(i=0; i<object.goal.length; i++){
                if (object.goal[i].pairID == goalID){
                    goalIndex = i;
                    break;
                }
            }
            if (goalIndex == -1) goalID = -1;
        }
        if(wpid != -1){
            for(j=0; j<object.waypoint.length; j++){
                if (object.waypoint[j].WPID == wpid){
                    wpIndex = j;
                    break;
                }
            }
            if (wpIndex == -1) wpid = -1;
        }

        if( isInCanvas(x,y) && speed > 0) {
            this.agt[this.agt.length] = [x,y,goalID,wpid,speed];
            if(this.validate(this.agt.length-1)){
                if(goalIndex != -1)
                    object.makeLink(T_PED,T_WAYPOINT,this.agt.length-1,goalIndex);
                if(wpIndex != -1)
                    object.makeLink(T_PED,T_GOAL,this.agt.length-1,wpIndex);
            }
        } else {
            message("Agent generation error: "+ (0<=x) + (x<=canvasX) + (0<=y) +
                    (y<=canvasY) + existgoalID + existWPID + (speed > 0));
            return false;
        }
        return true;
    };


    this.strictValidate = function(){
        for(loop=0; loop<this.agt.length; loop++){
            if(this.agt[loop] == false){
                this.agt.splice(loop,1);
                loop --;
                continue;
            }
            if(this.agt[loop][2] == -1){
                this.remove(loop,false);
                this.agt.splice(loop,1);
                loop --;
                continue;
            } else {
                for (j=0; j<object.goal.length; j++){
                    if(object.goal[j].pairID == this.agt[loop][2])
                        break;
                }
                if (j == object.goal.length){
                    this.remove(loop,false);
                    this.agt.splice(loop,1);
                    loop --;
                    continue;
                }
            }
            
            if(this.agt[loop][3] == -1) {
                this.agt[loop][3] = object.goal[j].myWPID;
            } else {
                for (k=0; k<object.waypoint.length; k++){
                    if(object.waypoint[k].WPID == this.agt[loop][3])
                        break;
                }
                if (k == object.waypoint.length){
                    this.agt[loop][3] = object.goal[j].myWPID;
                }
            }
        }
        
        for(loop=0; loop<this.agt.length; loop++){
            if(this.agt[loop][2] != -1)
                for(j=0; j<object.goal.length; j++)
                    if(this.agt[loop][2] == object.goal[j].pairID)
                        object.links[object.links.length] = [T_PED, T_GOAL, loop, j];
            if(this.agt[loop][3] != -1)
                for(j=0; j<object.waypoint.length; j++)
                    if(this.agt[loop][3] == object.waypoint[j].WPID)
                        object.links[object.links.length] = [T_PED, T_WAYPOINT, loop, j];
        }
    }


    this.remove = function(num){
        if(this.agt.length <= num) return -1;
        if (arguments.length >= 2){
            for(i=num;i<num+arguments[1];i++){
                this.remove(i);
            }
            revertAll();
            return true;
        }
        if(this.agt[num][2] != -1){
            object.cleanupLink(T_PED, T_GOAL, num);
        }
        if(this.agt[num][3] != -1){
            object.cleanupLink(T_PED, T_WAYPOINT, num);
        }
        this.agt[num] = false;

        return true;
    };


    this.show = function(){
        for(i=0;i<this.agt.length;i++){
            if(this.agt[i] != false)
                fillShape(S_CIRCLE, this.agt[i][0], this.agt[i][1], canvasRatio,360,0, agentColor);
        }
    };

    this.changeParameter = function(num, param, val){
        this.agt[num][param] = Number(val);
        this.validate(num);
        revertAll();
    };

    this.list = function(){
        $table =  $("#tab-peds > table.container").text('');
        $table.append("<tr class=\"listhead\"><th>id</th><th>x</th><th>y</th>"+
                               "<th>speed</th><th>del</th></tr>");
        for (i=0; i<this.agt.length; i++){
            if(this.agt[i] == false) continue;
            s = '<tr class="object" id=agent'+ i + ' onmousedown="agent.mark('+i+')" onmouseup="agent.unmark('+i+')">';
            s += "<td>"+i+"</td>"+
                "<td><input type='text' id='x"+i+"' onchange='agent.changeParameter("+i+",0,$(this).val())'"+
                    " class='agentParam' onfocus='this.select()' size='3' value='"+this.agt[i][0]+"' /></td>"+
                "<td><input type='text' id='y"+i+"' onchange='agent.changeParameter("+i+",1,$(this).val())'"+
                    " class='agentParam' onfocus='this.select()' size='3' value='"+this.agt[i][1]+"' /></td>"+
                "<td><input type='text' id='speed"+i+"' onchange='agent.changeParameter("+i+",3,$(this).val())'"+
                    " class='agentParam' onfocus='this.select()' size='3' value='"+this.agt[i][4]+"' /></td>" + 
                "<td><a class='tool' onclick='agent.remove("+i+"); revertAll();'>[D]</a></td></tr>";
            $table.append(s);
        }
    };

    this.validate = function(num){
        return true;
    };

    this.mark = function(num){
        if(this.agt[num] == false) return false;
        object.selectLinkObject(T_PED,num);
        fillShape(S_CIRCLE, this.agt[num][0], this.agt[num][1], canvasRatio,360,0, markupColor);
    };
    this.unmark = function(num){
        if(this.agt[num] == false) return false;
        fillShape(S_CIRCLE, this.agt[num][0], this.agt[num][1], canvasRatio,360,0, agentColor);
    };


    this.putPatterned = function(startX, startY, diffX, diffY, numX, numY, goalID, WPID, speed){
        if (diffX == 0 || diffY == 0 || !isInCanvas(startX,startY) ||
            !isInCanvas(startX + diffX*numX, startY + diffY*numY) ) return false;
        for(i=0; i<object.goal.length; i++){
            if (object.goal[i].pairID == goalID){
                break;
            }
        }
        if(i == object.goal.length)
            goalID = -1;
        for(i=0; i<object.waypoint.length; i++){
            if (object.waypoint[i].WPID == WPID){
                break;
            }
        }
        if(i == object.waypoint.length)
            goalID = -1;
        
        for (mx=0; mx<numX; mx++){
            for (my=0; my<numY; my++){
                this.add(startX + diffX * mx, startY + diffY * my, goalID, WPID, speed);
            }
        }
        revertAll();
    };
}
