// Copyright (C) 2011 by TOMITA Hiroshi.
//     This program is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.

//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.


// constants
const S_RECT = 0;
const S_STROKERECT = 1;
const S_CIRCLE = 2;
const S_STROKECIRCLE = 3;

const T_BLANK = 1000;
const T_BLOCK = 1001;
const T_START = 1002;
const T_GOAL = 1003;
const T_ATTR = 1004;
const T_WAYPOINT = 1010;
const T_PED = 1011;

const M_MAP = 2000;
const M_LINK= 2001;
const M_AGENT = 2002;

var canvasX = 640;
var canvasY = 480;
var canvasRatio = 1;

var objColor = Array();
objColor[T_BLANK]="rgb(0,0,0)";
objColor[T_BLOCK]="rgb(40,40,240)";
objColor[T_START]="rgb(100,100,200)";
objColor[T_GOAL]="rgb(240,40,40)";
objColor[T_WAYPOINT]="rgb(250,250,50)";

const markupColor = "rgba(255,255,0,0.7)";
const linkupColor = "rgba(240,100,240,0.7)";
const linkFromColor = "rgba(200,0,200,0.7)";
const agentColor = "rgb(200,10,200)";
const linklineColor = "rgb(100,250,100)";
const WP_markupColor = "rgba(0,100,255,0.7)";

var mode = 0;

var beginX=0;
var beginY=0;
var prevX=0;

var drawing = false;
var presentShape = -1;
var presentType = -1;
var presentPoint = -1;
var agent = object = null;
var useImage = false;
var bg = new Image();
bg.onload = function(){
    useImage = true;
    revertAll();
};

$(function(){
    agent = new CAgent(new Array);
    object = new CObject(new Array, new Array,
                             new Array, new Array);
    var c = document.getElementById("myCanvas");
    c.addEventListener("mousedown", startObj, true);
    c.addEventListener("mousemove", drawObj, true);
    c.addEventListener("mouseup", finishObj, true);
    c.addEventListener("mouseout", 
                       function(ev) {
                           drawing = false;
                           (getContext()).clearRect(beginX,beginY,1,1);
                       },true);
    setShape(S_RECT);
    setType(T_BLOCK);
    setAgentSelector(T_PED);
    setCanvas(600,600,3);
    object.list();
    agent.list();
    mapModeInit();
    $('#tp_link_sel_from').attr("checked","checked");

    // actions
    $('#em_map').click(mapModeInit);
    $('#em_link').click(linkModeInit);

    // dialogs
    dialogSetup();

    // tabs
    $('#list_tabs').tabs();
});

function mapModeInit(){
    $("#em_map_radio").attr("checked","checked");
    $("#em_link_radio").removeAttr("checked");

    if(presentType == T_PED || presentType == T_WAYPOINT){
        agentModeInit();
        return;
    }
// tp = ToolPallet
    $("#tp_edit").css("display", "block");
    $("#tp_link").css("display", "none");
    $("#tp_agent").css("display", "none");

    finishLinkMode();
    mode = M_MAP;
    revertAll();
}

function linkModeInit(){
    $("#em_link_radio").attr("checked","checked");
    $("#em_map_radio").removeAttr("checked");

// tp = ToolPallet
    $("#tp_edit").css("display", "none");
    $("#tp_link").css("display", "block");
    $("#tp_agent").css("display", "none");

    finishMapMode();
    mode = M_LINK;
    linking = false;
    revertAll();
}

function agentModeInit(){
    $("#em_link_radio").removeAttr("checked");
    $("#em_map_radio").attr("checked","checked");

// tp = ToolPallet
    $("#tp_edit").css("display", "none");
    $("#tp_link").css("display", "none");
    $("#tp_agent").css("display", "block");

    finishLinkMode();
    finishMapMode();

    mode = M_AGENT;
    revertAll();
}
function finishLinkMode(){
    linking = false;
}

function finishMapMode(){
    if(drawing) drawing=false;
}


function countObjParam(obj){
    var i = 0;
    for (j in obj)
        i++;
    return i;
}


function isEmpty(obj){
    for (b in obj) return false;
    return true;
}
