// TODO:

function getContext (){ 
    return document.getElementById('myCanvas').getContext('2d');
}

function setCanvas(width,height,ratio) {
    canvasX = width;
    canvasY = height;
    canvasRatio = ratio;
    $('#sideBar').css("position", "absolute").css("left",width+"px");
    $('#myCanvas').attr('width',width).attr('height',height);
    $('#canvasWidth').val(width);
    $('#canvasHeight').val(height);
    $('#canvasRatio').val(ratio);
    clearAll(); // re-displaying is included
}

function isInCanvas(x,y){
    if(0 < x && x < canvasX && 0 < y && y < canvasY) return true;
    else return false;
}

// false: canvas only
// true : toolbar only
function revertAll(){
    drawing = false;
    if(arguments.length!=0){
        if(! arguments[0]){
            (getContext()).clearRect(0,0,canvasX,canvasY);
            if(useImage)
                (getContext()).drawImage(bg, 0, 0, canvasX, canvasY);

            object.show();
            object.showLinkLine();
            agent.show();
        } else {
            object.list();
            agent.list();
        }
    } else {
        (getContext()).clearRect(0,0,canvasX,canvasY);
        if(useImage)
            (getContext()).drawImage(bg, 0, 0, canvasX, canvasY);
        object.show();
        object.showLinkLine();
        agent.show();
        object.list();
        agent.list();
    }
}

function startObj (ev){
    if (mode == M_MAP){
        drawing = true;
        prevX = beginX=ev.pageX;
        beginY=ev.pageY;
        putPoint(beginX,beginY,"rgba(255,0,0,1)");
        $('#pushx').val(ev.pageX);
        $('#pushy').val(ev.pageY);
        (getContext()).save();
        return true;
    } else if (mode == M_AGENT){
        switch (presentPoint){
        case T_PED:
            agent.add(ev.pageX,ev.pageY,Number($('#agt_goalid').val()),
                      Number($('#agt_wpid').val()), Number($('#agt_speed').val()));
            break;
        case T_WAYPOINT:
            object.addWP(ev.pageX, ev.pageY,false);
            break;
        }
        revertAll();
    }
    return false;
}

function drawObj (ev){
    $('#cursorx').val(ev.pageX);
    $('#cursory').val(ev.pageY);
    if (mode == M_MAP && drawing){
        switch (presentShape){
        case S_CIRCLE:
        case S_STROKECIRCLE:
            (getContext()).clearRect(beginX,beginY,prevX-beginX,1);
            prevX = ev.pageX;
            fillShape(S_RECT,beginX+(prevX-beginX)/2,beginY+0.5,prevX-beginX,
                      1,0,"rgb(255,0,0)");
            break;
        }
    }
}

function finishObj (ev){
    if (mode == M_MAP && drawing){
        x = beginX;
        y = beginY;
        w = ev.pageX - beginX;
        h = ev.pageY - beginY;
        drawing = false;
        (getContext()).clearRect(beginX,beginY,1,1);
        if (isInCanvas(ev.pageX,ev.pageY)){
            switch (presentShape){
            case S_RECT:
            case S_STROKERECT:
                object.add(presentShape, presentType,x+w/2,y+h/2, w,h,0);
                break;
            case S_CIRCLE:
            case S_STROKECIRCLE:
                object.add(presentShape, presentType, x, y, w, 360, 0);
                break;
            }
        }
        revertAll();
    }
}

function clearAll(){
    object = new CObject(new Array,new Array, new Array, new Array);
    agent = new CAgent(new Array);
    revertAll();
}

function drawLine(fromx,fromy,tox,toy,style){
    context = getContext();
    context.beginPath();
    context.strokeStyle = style;
    context.moveTo(fromx,fromy);
    context.lineTo(tox,toy);
    context.stroke();
}

function fillShape (shape,x,y,w,h,deg,style){
    context = getContext();
    switch (shape){
    case S_RECT:
        context.save();
        context.fillStyle = style;
        context.translate(x,y);
        context.rotate(-Math.PI*(deg/180));
        context.fillRect(-w/2,-h/2,w,h);
        context.restore();
        break;
    case S_STROKERECT:
        context.save();
        context.translate(x,y);
        context.rotate(-Math.PI*(deg/180));
        context.strokeStyle = style;
        context.strokeRect(-w/2,-h/2,w,h);
        context.restore();
        break;
    case S_CIRCLE:
        context.fillStyle = style;
        context.beginPath();
        context.arc(x,y,w,-Math.PI*((deg+h)/180),-Math.PI*(deg/180),false);
        context.fill();
        break;
    case S_STROKECIRCLE:
        context.strokeStyle = style;
        context.beginPath();
        context.arc(x,y,w,-Math.PI*((deg+h)/180),-Math.PI*(deg/180),false);
        context.stroke();
        break;
    }
}
function putPoint (x,y,style) {
    fillShape(S_RECT,x,y,1,1,0,style);
}
