// Copyright (C) 2011 by TOMITA Hiroshi.
//     This program is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.

//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.


var aspfDone = false;
var cons = new Object;

function setShape(shape){
    switch (shape){
    case S_RECT:
        presentShape = shape;
        $('#srect').css('background-position', '0px -0px');
        $('#scircle').css('background-position', '-16px 0px');
        $('#rect').css('background-position', '-32px -16px');
        $('#circle').css('background-position', '-48px 0px');
        break;

    case S_STROKERECT:
        if (presentType == T_START){
            message("StrokeRect is not usable with TypeStart");
            return false;
        }
        if (presentType == T_GOAL){
            message("StrokeRect is unavailable with TypeGoal");
            return false;
        }
        presentShape = shape;
        $('#srect').css('background-position', '0px -16px');
        $('#scircle').css('background-position', '-16px 0px');
        $('#rect').css('background-position', '-32px 0px');
        $('#circle').css('background-position', '-48px 0px');
        break;

    case S_CIRCLE:
        presentShape = shape;
        $('#srect').css('background-position', '0px 0px');
        $('#scircle').css('background-position', '-16px 0px');
        $('#rect').css('background-position', '-32px 0px');
        $('#circle').css('background-position', '-48px -16px');
        break;

    case S_STROKECIRCLE:
        if (presentType == T_START){
            message("StrokeRect is not usable with TypeStart");
            return false;
        }
        if (presentType == T_GOAL){
            message("StrokeRect is unavailable with TypeGoal");
            return false;
        }
        presentShape = shape;
        $('#srect').css('background-position', '0px 0px');
        $('#scircle').css('background-position', '-16px -16px');
        $('#rect').css('background-position', '-32px 0px');
        $('#circle').css('background-position', '-48px 0px');
        break;
    }
    return true;
}

function setType(type){
    presentType = type;
    switch (type){
    case T_BLOCK:
        if(mode != M_LINK && mode != M_MAP)
            mapModeInit();
        $('#block').css('background-position', '-64px -16px');
        $('#start').css('background-position', '-80px 0px');
        $('#goal').css('background-position', '-96px 0px');
        $('#attraction').css('background-position', '-112px 0px');
        break;
    case T_START:
        if(mode != M_LINK && mode != M_MAP)
            mapModeInit();
        if (presentShape == S_STROKECIRCLE){
            message("shape is automatically changed to CIRCLE.");
            setShape(S_CIRCLE);
        }
        if (presentShape == S_STROKERECT){
            message("shape is automatically changed to RECT");
            setShape(S_RECT);
        }
        $('#block').css('background-position', '-64px 0px');
        $('#start').css('background-position', '-80px -16px');
        $('#goal').css('background-position', '-96px 0px');
        $('#attraction').css('background-position', '-112px 0px');
        break;
    case T_GOAL:
        if(mode != M_LINK && mode != M_MAP)
            mapModeInit();
        if (presentShape == S_STROKECIRCLE){
            message("shape is automatically changed to CIRCLE.");
            setShape(S_CIRCLE);
        }
        if (presentShape == S_STROKERECT){
            message("shape is automatically changed to RECT");
            setShape(S_RECT);
        }
        $('#block').css('background-position', '-64px 0px');
        $('#start').css('background-position', '-80px 0px');
        $('#goal').css('background-position', '-96px -16px');
        $('#attraction').css('background-position', '-112px 0px');
        break;
    case T_WAYPOINT:
        if(mode != M_LINK && mode != M_AGENT){
            agentModeInit();
        }
        setAgentSelector(T_WAYPOINT);
        break;
    case T_PED:
        if(mode != M_LINK && mode != M_AGENT){
            agentModeInit();
        }
        setAgentSelector(T_PED);
        break;
    }
    presentType = type;
}


function importDialog(){
    $('#dialog_input').dialog({
        bgiframe: true,
        autoOpen: true,
        width: "360px",
        modal: true,
        buttons: {
            'Load' : function() {
                data = $('#objectData').val();
                $(this).dialog("close");
                loadInfo(data);
            },
            'Cancel' : function() {$(this).dialog("close"); }
        }
    });
}

function stringReplaceAll(str, from, to){
    while(str != (t = str.replace(from,to)))
        str = t;
    return str;
}

function setArtisocString(data){
    mapX = parseInt(canvasX/canvasRatio);
    mapY = parseInt(canvasY/canvasRatio);

    data = stringReplaceAll(data, "$PED_COUNT$", agent.agt.length);
    data = stringReplaceAll(data, "$BLOCK_COUNT$", object.block.length);
    data = stringReplaceAll(data, "$START_COUNT$", object.start.length);
    data = stringReplaceAll(data, "$GOAL_COUNT$", object.goal.length);
    data = stringReplaceAll(data, "$WP_COUNT$", object.waypoint.length);

    data = stringReplaceAll(data, "$MAP_X$", parseInt(canvasX/canvasRatio));
    data = stringReplaceAll(data, "$MAP_Y$", parseInt(canvasY/canvasRatio));

    if(outputType == 'Helbing'){
        data = data.replace("$PARAM_DT$", cons.dt)
            .replace("$PARAM_CELLSIZE$", cons.cellsize)
            .replace("$PARAM_GOAL$", cons.goal);
    }

    x = y = goalid = nextwpid = speed = '';
    if(agent.agt.length != 0){
        for(i=0;i<agent.agt.length-1;i++){
            x += agent.agt[i][0]/canvasRatio + " ,";
            y += mapY - agent.agt[i][1]/canvasRatio + " ,";
            goalid += agent.agt[i][2] + " ,";
            nextwpid += agent.agt[i][3] + " ,";
            speed += agent.agt[i][4] + " ,";
        }
        x += agent.agt[agent.agt.length-1][0]/canvasRatio;
        y += mapY - agent.agt[agent.agt.length-1][1]/canvasRatio;
        goalid += agent.agt[agent.agt.length-1][2];
        nextwpid += agent.agt[agent.agt.length-1][3];
        speed += agent.agt[agent.agt.length-1][4];
    }

    data = data.replace("$$PED_X$$", x)
        .replace("$$PED_Y$$", y)
        .replace("$$PED_GOALID$$", goalid)
        .replace("$$PED_NEXTWPID$$", nextwpid)
        .replace("$$PED_SPEED$$", speed);

    x = y = width = height = degree = shape = "";
    if(object.block.length != 0){
        for(i=0; i<object.block.length-1; i++){
            x += object.block[i].x/canvasRatio + ",";
            y += mapY - object.block[i].y/canvasRatio + ",";
            width += object.block[i].width/canvasRatio + ",";
            height += ((object.block[i].shape == S_CIRCLE ||
                        object.block[i].shape == S_STROKECIRCLE)
                       ? object.block[i].height
                       : object.block[i].height/canvasRatio) + ",";
            degree += object.block[i].degree + ",";
            shape += object.block[i].shape + ",";
        }

        x += object.block[object.block.length-1].x/canvasRatio;
        y += mapY - object.block[object.block.length-1].y/canvasRatio;
        width += object.block[object.block.length-1].width/canvasRatio;
        height += ((object.block[object.block.length-1].shape == S_CIRCLE ||
                    object.block[object.block.length-1].shape == S_STROKECIRCLE)
                   ? object.block[object.block.length-1].height
                   : object.block[object.block.length-1].height/canvasRatio);
        degree += object.block[object.block.length-1].degree;
        shape += object.block[object.block.length-1].shape;
    }

    data = data.replace("$$BLOCK_X$$", x)
        .replace("$$BLOCK_Y$$", y)
        .replace("$$BLOCK_WIDTH$$", width)
        .replace("$$BLOCK_HEIGHT$$", height)
        .replace("$$BLOCK_SHAPE$$", shape)
        .replace("$$BLOCK_DEGREE$$", degree);

    x = y = width = height = degree = shape = startID = goalID = speed = firstWPID = "";
    velom = velos = "";
    if(object.start.length != 0){
        for(i=0; i<object.start.length; i++){
            x += object.start[i].x/canvasRatio + ",";
            y += mapY - object.start[i].y/canvasRatio + ",";
            width += object.start[i].width/canvasRatio + ",";
            height += ((object.start[i].shape == S_CIRCLE ||
                        object.start[i].shape == S_STROKECIRCLE)
                       ? object.start[i].height
                       : object.start[i].height/canvasRatio) + ",";
            degree += object.start[i].degree + ",";
            shape += object.start[i].shape + ",";
            startID += object.start[i].startID + ",";
            goalID += object.start[i].goalID + ",";
            speed += object.start[i].generateSpeed + ",";
            firstWPID += object.start[i].firstWPID + ",";
            velom += object.start[i].velocityMean + ",";
            velos += ((object.start[i].velocitySD==0)? 0.000001
                      : object.start[i].velocitySD) + ",";
        }
        x = x.substr(0,x.length-1);
        y = y.substr(0,y.length-1);
        width = width.substr(0,width.length-1);
        height = height.substr(0,height.length-1);
        degree = degree.substr(0,degree.length-1);
        shape = shape.substr(0,shape.length-1);
        startID = startID.substr(0,startID.length-1);
        goalID = goalID.substr(0,goalID.length-1);
        speed = speed.substr(0,speed.length-1);
        firstWPID = firstWPID.substr(0,firstWPID.length-1);
        velom = velom.substr(0,velom.length-1);
        velos = velos.substr(0,velos.length-1);
            
    }

    data = data.replace("$$START_X$$", x)
        .replace("$$START_Y$$", y)
        .replace("$$START_WIDTH$$", width)
        .replace("$$START_HEIGHT$$", height)
        .replace("$$START_DEGREE$$", degree)
        .replace("$$START_SHAPE$$", shape)
        .replace("$$START_STARTID$$", startID)
        .replace("$$START_GOALID$$", goalID)
        .replace("$$START_SPEED$$", speed)
        .replace("$$START_FIRSTWPID$$", firstWPID)
        .replace("$$START_VELOCITYMEAN$$", velom)
        .replace("$$START_VELOCITYSD$$", velos);

    x = y = width = height = degree = shape = pairID = nextStartID = "";
    if(object.goal.length != 0){
        for(i=0; i<object.goal.length-1; i++){
            x += object.goal[i].x/canvasRatio + ",";
            y += mapY - object.goal[i].y/canvasRatio + ",";
            width += object.goal[i].width/canvasRatio + ",";
            height += ((object.goal[i].shape == S_CIRCLE ||
                        object.goal[i].shape == S_STROKECIRCLE)
                       ? object.goal[i].height 
                       : object.goal[i].height/canvasRatio) + ",";
            degree += object.goal[i].degree + ",";
            shape += object.goal[i].shape + ",";
            pairID += object.goal[i].pairID + ",";
            nextStartID += object.goal[i].nextStartID + ",";
        }

        x += object.goal[object.goal.length-1].x/canvasRatio;
        y += mapY - object.goal[object.goal.length-1].y/canvasRatio;
        width += object.goal[object.goal.length-1].width/canvasRatio;
        height += ((object.goal[object.goal.length-1].shape == S_CIRCLE ||
                    object.goal[object.goal.length-1].shape == S_STROKECIRCLE)
                   ? object.goal[object.goal.length-1].height
                   : object.goal[object.goal.length-1].height/canvasRatio);
        degree += object.goal[object.goal.length-1].degree;
        shape += object.goal[object.goal.length-1].shape;
        pairID += object.goal[object.goal.length-1].pairID;
        nextStartID += object.goal[object.goal.length-1].nextStartID;
    }

    data = data.replace("$$GOAL_X$$", x)
        .replace("$$GOAL_Y$$", y)
        .replace("$$GOAL_WIDTH$$", width)
        .replace("$$GOAL_HEIGHT$$", height)
        .replace("$$GOAL_DEGREE$$", degree)
        .replace("$$GOAL_SHAPE$$", shape)
        .replace("$$GOAL_PAIRID$$", pairID)
        .replace("$$GOAL_NEXTSTARTID$$", nextStartID);

    x = y = nextWPID = WPID = "";
    if(object.waypoint.length != 0){
        for(i=0; i<object.waypoint.length-1; i++){
            x += object.waypoint[i].x/canvasRatio + ",";
            y += mapY - object.waypoint[i].y/canvasRatio + ",";
            nextWPID += object.waypoint[i].nextWPID + ",";
            WPID += object.waypoint[i].WPID + ",";
        }

        x += object.waypoint[object.waypoint.length-1].x/canvasRatio;
        y += mapY - object.waypoint[object.waypoint.length-1].y/canvasRatio;
        nextWPID += object.waypoint[object.waypoint.length-1].nextWPID;
        WPID += object.waypoint[object.waypoint.length-1].WPID;
    }

    data = data.replace("$$WP_X$$", x)
        .replace("$$WP_Y$$", y)
        .replace("$$WP_NEXTWPID$$", nextWPID)
        .replace("$$WP_WPID$$", WPID);


// setup wall object
    if($('input[name=type]:checked').val() == 'ASPF'){
// Temporarily off for double generation
        wall = new Array;
        for(i=0; i<mapY; i++){
            wall[i] = new Array;
            for(j=0; j<mapX; j++){
                wall[i][j] = 0;
            }
        }
        for(i=0; i<object.block.length; i++){
            switch(object.block[i].shape){
            case S_RECT:
                for(x=-object.block[i].width/2/canvasRatio; x<=object.block[i].width/2/canvasRatio; x+=1){
                    for(y=-object.block[i].height/2/canvasRatio; y<=object.block[i].height/2/canvasRatio; y+=1){
                        wx = parseInt(object.block[i].x/canvasRatio + x*Math.cos(object.block[i].degree*Math.PI/180) + y*Math.sin(object.block[i].degree*Math.PI/180));
                        wy = parseInt(object.block[i].y/canvasRatio + y*Math.cos(object.block[i].degree*Math.PI/180) - x*Math.sin(object.block[i].degree*Math.PI/180));
                        if(0 <= wx && wx < mapX && 0 <= wy && wy < mapY)
                            wall[wy][wx] = 1;
                    }
                }
                break;
            case S_CIRCLE:
                for(x=-object.block[i].width; x<=object.block[i].width; x+=canvasRatio){
                    for(y=-object.block[i].width; y<=object.block[i].width; y+=canvasRatio){
                        if(Math.sqrt(x*x+y*y) < object.block[i].width){
                            wx = parseInt( object.block[i].x/canvasRatio + x/canvasRatio );
                            wy = parseInt( object.block[i].y/canvasRatio + y/canvasRatio );
                            if(0 <= wx && wx < mapX && 0 <= wy && wy < mapY)
                                wall[wy][wx] = 1;
                        }
                    }
                }
                break;
            case S_STROKECIRCLE:
                delta = canvasRatio/object.block[i].width;
                for(rad=object.block[i].degree*Math.PI/180; rad<object.block[i].degree*Math.PI/180+object.block[i].height*Math.PI/180; rad+=delta){
                    wx = parseInt(object.block[i].x/canvasRatio + object.block[i].width*Math.cos(rad)/canvasRatio);
                    wy = parseInt(object.block[i].y/canvasRatio - object.block[i].width*Math.sin(rad)/canvasRatio);
                    if(0 <= wx && wx < mapX && 0 <= wy && wy < mapY)
                        wall[wy][wx] = 1;
                    wx = parseInt(object.block[i].x/canvasRatio + (object.block[i].width-canvasRatio)*Math.cos(rad)/canvasRatio);
                    wy = parseInt(object.block[i].y/canvasRatio - (object.block[i].width-canvasRatio)*Math.sin(rad)/canvasRatio);
                    if(0 <= wx && wx < mapX && 0 <= wy && wy < mapY)
                        wall[wy][wx] = 1;
                }
                break;
            }
        }
        wallNum = 0;
        xs = "";
        ys = "";
        s= "";
        for(i=0;i<mapY;i++){
            for(j=0;j<mapX;j++){
                if(wall[mapY - i-1][j]){
                    wallNum ++;
                    xs += j +" ,";
                    ys += i +" ,";
                }
                    s += wall[i][j] ? "1" : "-";
            }
                s += "\n";
        }
        xs = xs.substr(0,xs.length-2);
        ys = ys.substr(0,ys.length-2);
        data = stringReplaceAll(data,"$WALL_COUNT$",wallNum);//ここから
        data = data.replace("$$WALL_X$$",xs).replace("$$WALL_Y$$", ys);
    }
    
    $('#output_artisoc').val(data);
    $('#form_export').submit()
}


function output(){
    $('#output_temp').val(outputInfo());
    // strict validity check
    object.strictValidate();
    agent.strictValidate();
// raw output
    $('#output_raw').val(outputInfo());

// artisoc output
    openOutputDialog($('input[name=type]:checked').val());

// show only objects
    (getContext()).clearRect(0,0,canvasX,canvasY);
    object.show();
    $("#output_img_noagent")
        .val((document.getElementById("myCanvas")).toDataURL('image/jpeg'));

    revertAll();
}

function openOutputDialog(type){
    outputType = type;
    switch(type){
    case 'ASPF':
        $('#output_dt').attr('disabled',true);
        $('#output_cellsize').attr('disabled','disabled');
        $('#dialog_output input[name=goto]').attr('disabled','disabled').removeAttr('checked');
        break;
    case 'Helbing':
        $('#output_dt').removeAttr('disabled');
        $('#output_cellsize').removeAttr('disabled');
        $('#dialog_output input[name=goto]').removeAttr('disabled');
        break;
    }
    $('#dialog_output').dialog('open');
}

// show error message
function message(str){
    $('#messageLog').val(str + "\n" + $('#messageLog').val()); // add to head
}

function _getIMG(id){
    switch (id){
    case S_RECT:
        return '<span class="objecticon" style="background-position: -16px 0px;">';
    case S_STROKERECT:
        return '<span class="objecticon" style="background-position: 0px 0px;">';
    case S_CIRCLE:
        return '<span class="objecticon" style="background-position: -48px 0px;">';
    case S_STROKECIRCLE:
        return '<span class="objecticon" style="background-position: -32px 0px;">';
    case T_BLOCK:
        return '<span class="objecticon" style="background-position: 0px -16px;">';
    case T_START:
        return '<span class="objecticon" style="background-position: -16px -16px;">';
    case T_GOAL:
        return '<span class="objecticon" style="background-position: -32px -16px;">';
    case T_WAYPOINT:
        return '<span class="objecticon" style="background-position: -48px -16px;">';
    case T_PED:
        return '<span class="icon" style="background-position: -128px -0px"></span>';
    }
}

function dialogSetup(){
    // put pedestrians in pattern dialog
    $('#dialog_patternPed').dialog({
            bgiframe: true,
            autoOpen: false,
            width: "550px",
            modal: true,
                buttons: {
                'Apply': function(){
                    agent.putPatterned(
Number($('#pp_beginX').val()),Number($('#pp_beginY').val()),
Number($('#pp_spaceX').val()),Number($('#pp_spaceY').val()),
Number($('#pp_numX').val()),Number($('#pp_numY').val()),
Number($('#pp_goalID').val()),Number($('#pp_wpid').val()),
Number($('#pp_speed').val())
);
                    $(this).dialog('close');
                },
                'Cancel': function(){
                    $(this).dialog('close');
                }
            }
        });
    // output dialog
    $('#dialog_output').dialog({
        bgiframe: true,
        autoOpen: false,
        width: "700px",
        modal: true,
        buttons: {
                'Export' : function(){
                    
                    if(outputType == 'Helbing'){
                        cons.dt = Number($('#output_dt').val());
                        cons.cellsize = Number($('#output_cellsize').val());
                        cons.goal = ($('#dialog_output input[name=goto]:checked')
                                     .val()=="goal") ? 1 : 0;
                        model = $.get('templates/Helbing_template.model',setArtisocString);
                    } else {
                        model = $.get('templates/ASPF_template.model',setArtisocString);
                    }
                    $(this).dialog("close");
                }
            }});
}

// Set toolpallet for waypoint or pedestrian
function setAgentSelector(type){
    switch(type){
    case T_WAYPOINT:
        $('div.for_waypoint').css('display','block');
        $('table.for_pedestrian').css('display','none');
        presentPoint = T_WAYPOINT;
        break;
    case T_PED:
        $('div.for_waypoint').css('display','none');
        $('table.for_pedestrian').css('display','block');
        presentPoint = T_PED;
        break;
    }
}

// load objects from the JSON string
function loadInfo (str){
    json = JSON.parse(str);

    delete object;
    delete agent;

    var block = new Array,
        start = new Array,
        goal = new Array,
        waypoint = new Array;

    setCanvas(json.mapinfo.x, json.mapinfo.y, json.mapinfo.ratio);
    tmp = json.block.slice(0);
    for(i=0;i<tmp.length;i++){
        if(!isEmpty(tmp[i])){
            block[block.length] = tmp[i];
        }
    }
    tmp = json.start.slice(0);
    for(i=0;i<tmp.length;i++){
        if(!isEmpty(tmp[i])){
            start[start.length] = tmp[i];
        }
    }
    tmp = json.goal.slice(0);
    for(i=0;i<tmp.length;i++){
        if(!isEmpty(tmp[i])){
            goal[goal.length] = tmp[i];
        }
    }
    tmp = json.waypoint.slice(0);
    for(i=0;i<tmp.length;i++){
        if(!isEmpty(tmp[i])){
            waypoint[waypoint.length] = tmp[i];
        }
    }
    object = new CObject(block, start, goal, waypoint);
    agent = new CAgent(json.pedestrian.slice(0));

    revertAll();
}

// make a JSON string
function outputInfo (){
    outputObj = {
        mapinfo: {x:canvasX, y:canvasY, ratio:canvasRatio},
        block : object.block,
        start: object.start,
        goal : object.goal,
        pedestrian : agent.agt,
        waypoint : object.waypoint
    };

    return JSON.stringify(outputObj);
}
